//+------------------------------------------------------------------+
//|                                               Adapt Settings.mq5 |
//+------------------------------------------------------------------+

#property copyright "TheXpert"
#property link      "theforexpert@gmail.com"

#property version   "1.00"

#include <TheXpert/SettingsBar/SettingsBar.mqh>

SettingsBar Bar;

string GetSettingNameByID(int id)
{
   switch (id)
   {
      case 0: return "Bool Setting";
      case 1: return "Double Setting";
      case 2: return "Int Setting";
      case 3: return "Selection Setting";
      case 4: return "String Setting";
   }
   return "N\A";
}

void OnChartEvent(const int id, const long& lparam, const double& dparam, const string& sparam)
{
   Bar.OnChartEvent(id, lparam, dparam, sparam);
   
   if (id == CHARTEVENT_CUSTOM + EVENT_SETTING_CHANGED)
   {
      Print("Setting < ", GetSettingNameByID(lparam), " > has been changed to ", sparam);
   }

   ChartRedraw();
}

int OnInit()
{
   Bar.AddBoolSetting("Bool Setting", 0, true);
   Bar.AddDoubleSetting("Double Setting", 1, 2.35, 0.1, -20, 20);
   Bar.AddIntSetting("Int Setting", 2, 10, 2, 0, 100);
   
   SelectionTable TF;

   TF.AddSelection(PERIOD_M1, "1 Minute");
   TF.AddSelection(PERIOD_M5, "5 Minutes");
   TF.AddSelection(PERIOD_M15, "15 Minutes");
   TF.AddSelection(PERIOD_M30, "30 Minutes");
   TF.AddSelection(PERIOD_H1, "1 Hour");
   TF.AddSelection(PERIOD_H4, "4 Hours");
   TF.AddSelection(PERIOD_D1, "1 Day");

   Bar.AddSelectionSetting("Selection Setting", 3, PERIOD_M1, TF);
   
   Bar.AddStringSetting("String Setting", 4, "string value");

   Bar.SetTitle("Settings Example");

   return(0);
}

void OnDeinit(const int reason)
{
}

void OnTick()
{
}